﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="./../Packages/Beckhoff.TwinCAT.HMI.Framework.12.752.0/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    var Functions;
    (function (/** @type {globalThis.TcHmi.Functions} */ Functions) {
        var TcHmiJSBasic;
        (function (TcHmiJSBasic) {
            function ReadWriteFunction(Symbol, IsWrite) {
                TcHmi.Functions.TcHmiJSBasic.ClearUI();
                if (Symbol.length == 0) {
                    const StatusData = {
                        MoreInfo: undefined,
                        ErrorText: 'Symbol null!'
                    };
                    TcHmi.Functions.TcHmiJSBasic.ShowStatusToUI(StatusData, StatusData.ErrorText);
                    return;
                }

                async function asyncFunctionCall(sym, iswrite) {
                    let result;
                    try {
                        let symbol = '%s%'.concat(sym).concat('%/s%');
                        if (iswrite) {
                            result = await WritePLCVariable(symbol, true);
                        } else {
                            result = await ReadPLCVariable(symbol);                           
                        }
                        ShowStatusToUI(result, 'Success in asyncFunctionCall!');
                    }
                    catch (errorObject) {
                        TcHmi.Functions.TcHmiJSBasic.ShowStatusToUI(errorObject, errorObject.ErrorText);
                    }
                }
                asyncFunctionCall(Symbol, IsWrite);
            }
            TcHmiJSBasic.ReadWriteFunction = ReadWriteFunction;
        })(TcHmiJSBasic = Functions.TcHmiJSBasic || (Functions.TcHmiJSBasic = {}));
        Functions.registerFunctionEx('ReadWriteFunction', 'TcHmi.Functions.TcHmiJSBasic', TcHmiJSBasic.ReadWriteFunction);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);
